//=======================================================================
// Basic C++: classe Date
//      Utilization of class Date
//-----------------------------------------------------------------------
// Jean-Paul Rigault --- Copyright 2003
// $Id: main_Date.cpp,v 1.3 2004/11/07 10:52:52 jpr Exp $
//=======================================================================

#include "common_defs.h"
#include "Date.h"

int main()
{
    Date d0;

    MSG(Default Constructors and Display);

    OUT(d0);
    OUT(Date::today());

    MSG(Arithmetic operations);

    for (int i = 0; i <= 31; i++) OUT(d0 + i);

    Date d1(2003, 12, 31);
    OUT(d1);
    OUT(d1 + 0);
    OUT(d1 + 2);
    OUT(d1 + 365);

    Date d2(2003, 2, 1);
    OUT(d2);
    OUT(d2 - 0);
    OUT(d2 - 1);
    OUT(d2 - 2);

    for (int i = 0; i <= 31; i++) OUT(d0 - i);

    Date d3(2003, 1, 1);
    OUT(d3);
    OUT(d3 - 1);
    OUT(d3 - 365);

    OUT(d0 - (d0 + 1));
    OUT(d0 - (d0 - 1));
    Date d4(2002, 12, 31);
    OUT(d3);
    OUT(d4);
    OUT(d3 - d4);
    OUT(d4 - d3);
    OUT(d4 - (d4 + 366));

    OUT(Date(2003, 2, 10) - Date(2003, 6, 12));

    Date d5(2003, 5, 10);
    OUT(d5 + 5);

    MSG(Relational operators);
    OUT(Date(2004, 3, 20) <= Date(2004, 12, 8));
    OUT(Date(2004, 12, 8) < Date(2004, 3, 25));
    OUT(Date(2004, 12, 8) < Date(2004, 3, 20) + 5);

    Date din;
    cout << "Enter a date (yyyy/mm/dd, terminate with EOF): " << flush;

    try
    {
        while (cin >> din) 
        {
            OUT(din);
            cout << "Enter a date (yyyy/mm/dd, terminate with EOF): " << flush;
        }
    }
    catch (Date::Bad_Input)
    {
        cerr << "Bad format when reading date" << endl;
    }

}
