//=======================================================================
// Basic C++: class Expression: Ternary expressions
//      Specification and implementation
//-----------------------------------------------------------------------
// Jean-Paul Rigault --- Copyright 2004
// $Id: Ternary.h,v 1.3 2005/02/08 10:58:27 jpr Exp $
//=======================================================================

#ifndef _TERNARY_H_
#define _TERNARY_H_

#include "Expr.h"

class Ternary_Expr : public Expr
{
protected:
    Expr *cond;
    Expr *opl, *opr;
public:
    Ternary_Expr(Expr *cd, Expr *pe1, Expr *pe2)
        : cond(cd), opl(pe1), opr(pe2)
    {}
};

class Ternary_Conditional : public Ternary_Expr
{
public:
    Ternary_Conditional(Expr *cd, Expr *pe1, Expr *pe2)
        : Ternary_Expr(cd, pe1, pe2)
    {}
    virtual int eval() const
    {
        return cond->eval() ? opl->eval() : opr->eval();
    }

};

#endif
