//=======================================================================
// Basic C++: class Expression
//      Extension: variables and assignment
//-----------------------------------------------------------------------
// Jean-Paul Rigault --- Copyright 2003
// $Id: Variable.h,v 1.4 2005/02/08 15:57:10 jpr Exp $
//=======================================================================

#ifndef _VARIABLE_H_
#define _VARIABLE_H_

#include <map>
#include <string>
using namespace std;
#include "Expr.h"

// Storage area for variable values

static map<string, int> variables;

// Variable

class Variable_Ref : public Expr
{
private:
    string _id;
public:
    Variable_Ref(const string& id) : _id(id) {}
    virtual int eval() const {return variables[_id];}
    string id() const {return _id;}
};

// Assignment

class Assignment : public Expr
{
private:
    Variable_Ref *_pvar;
    Expr *_pright;

public:
    Assignment(Variable_Ref *pv, Expr *pr) : _pvar(pv), _pright(pr) {}
    virtual int eval() const
    {
        variables[_pvar->id()] = _pright->eval();
        return variables[_pvar->id()];
    }
};


#endif
