//=======================================================================
// Basic C++: a simple class template Priority_Queue
//      Specification and implementation
//-----------------------------------------------------------------------
// Jean-Paul Rigault --- Copyright 2003
// $Id: Priority_Queue.h,v 1.3 2005/02/20 14:50:29 jpr Exp $
//=======================================================================

#ifndef _PRIORITY_QUEUE_H_
#define _PRIORITY_QUEUE_H_

#include "List.h"

//----------------------------------------------------------------------- 
// A priority queue using Queue and List as a base implementation
//-----------------------------------------------------------------------
// We use public inheritance here, because Queue and Priority_Queue have 
// the same interface and it is logical that the latter be substitutable 
// for the former.
//-----------------------------------------------------------------------

template <typename ELEM>
class Priority_Queue : public Queue<ELEM>
{
public:

    // Put in the order. The implementation of get() in Queue is fine.   
    void put(ELEM e) {insert(e);}

    // Because of public inheritance, nothing else has to be redefined!
};

#endif
