//=======================================================================
// Basic C++: class Menu
//      Utilization of class Menu
//-----------------------------------------------------------------------
// Jean-Paul Rigault --- Copyright 2003
// $Id: main_Menu.cpp,v 1.2 2004/11/01 15:19:04 jpr Exp $
//=======================================================================

#include <iostream>
#include <cstdlib>
using namespace std;

#include "Menu_Item.h"
#include "Menu.h"
#include "Simple_Menu_Item.h"
#include "Walking_Menu.h"

//-----------------------------------------------------------------------
// Definition of a menu
//-----------------------------------------------------------------------

// Functions associated to actions

void News()
{
    cout << "************** Execution of NEWS" << endl;
}

void XWais()
{
    cout << "************** Execution of XWAIS" << endl;
}

void XFtp()
{
    cout << "************** Execution of XFTP" << endl;
}

void XArchie()
{
    cout << "************** Execution of XARCHIE" << endl;
}

void Emacs()
{
    cout << "************** Execution of EMACS" << endl;
}

void XLoad()
{
    cout << "************** Execution of XLOAD" << endl;
}

void Quit()
{
    cout << "************** Execution of QUIT" << endl;
    exit(0);
}

// Definition of menu items

static Menu_Item *Sub_Items[] = {
    new Simple_Menu_Item("news", News),
    new Simple_Menu_Item("xwais", XWais),
    new Simple_Menu_Item("xftp", XFtp),
    new Simple_Menu_Item("xarchie", XArchie),
};
const int NSub_Items = sizeof(Sub_Items) / sizeof(Menu_Item *);
static vector<Menu_Item *> V_Sub_Items(&Sub_Items[0], &Sub_Items[NSub_Items]);

static Menu_Item *Items[] = {
    new Simple_Menu_Item("emacs", Emacs),
    new Simple_Menu_Item("xload", XLoad),
    new Walking_Menu("COMMUNICATIONS", V_Sub_Items), 
    new Simple_Menu_Item("quit", Quit),
};
const int NItems = sizeof(Items) / sizeof(Menu_Item *);
static vector<Menu_Item *> V_Items(&Items[0], &Items[NItems]);

// The menu  itself

Menu The_Menu("THE MENU", V_Items);

// Displaying the menu in an infinite loop

int main()
{
    for (;;) The_Menu.activate();
    return 0;
}


