//--------------------------------------------------------------
//      A Stack class template Stack with exceptions
//              Implementation
//      This version uses vector<> internally.   
//--------------------------------------------------------------
// Jean-Paul Rigault: Basic C++
// $Id: Stack.cpp,v 1.1 2004/11/06 19:37:45 jpr Exp $
//--------------------------------------------------------------

#include "Stack.h"

template <typename ELEM>
Stack<ELEM>::Stack() : _top(0)
{
}

// We do not use push_front here, since it is highly unefficient for vectors
template <typename ELEM> 
void Stack<ELEM>::push(ELEM c)
{
    if (_top < _tab.size()) _tab[_top] = c;
    else _tab.push_back(c); // the vector must grow
    ++_top;
}

template <typename ELEM>
ELEM Stack<ELEM>::pop()
{
    if (_top <= 0) throw Empty();
    return _tab[--_top];
}

template <typename ELEM>
bool Stack<ELEM>::is_full() const
{
    return false;
}

template <typename ELEM>
bool Stack<ELEM>::is_empty() const
{
    return _top <= 0;
}
