//=======================================================================
// Basic C++: procedural programming
//      The bookmaker exercise
//-----------------------------------------------------------------------
// Jean-Paul Rigault --- Copyright 2003
// $Id: bookmaker.cpp,v 1.2 2004/11/01 15:19:04 jpr Exp $
//=======================================================================

#include <string>
#include <vector>
#include <iostream>
#include <fstream>
#include <stdexcept>
using namespace std;

// The structure defining the bookmaker's individual record
struct Bookrecord
{
    string _name;
    double _amount;
};

// A vector to store the transactions
vector<Bookrecord> records;



int main()
{
    string name;
    double amount;
    ifstream is("records.txt");

    // Read the individual records from the istream is
    while (is >> name >> amount)
    {
        Bookrecord rec = {name, amount};
        records.push_back(rec); 
    }

    // Print them out
    cout << "Records read" << endl;
    cout << "------------" << endl;
    for (unsigned i = 0; i < records.size(); ++i)
        cout << records[i]._name << '\t' << records[i]._amount << endl;

    cout << "\nEnter a name: " << flush;
    while (cin >> name)
    {
        double sum = 0.0;
        bool found = false;
        for (unsigned i = 0; i < records.size(); ++i)
        {
            if (records[i]._name == name)
            {
                found = true;
                sum += records[i]._amount;
            }
        }
        if (not found)
            cerr << "*** " << name << " not found" << endl;
        else
            cout << "Result for " << name << ": " << sum << endl;

        cout << "\nEnter a name: " << flush;    
    } 

    // Just checking exceptions

    cout << "Checking exceptions" << endl;

    // The following does not throw
    cout << "using operator[]: " << records[records.size()]._amount << endl;
   
    try
    {
        // This throws
        cout  << "using at(): " << records.at(records.size())._amount << endl;
    }
    catch (out_of_range)
    {
        cerr << "*** Out of Range exception" << endl;
    }

   
}

