//=======================================================================
// Basic C++: procedural programming
//      Passing parameter by reference
//-----------------------------------------------------------------------
// Jean-Paul Rigault --- Copyright 2003
// $Id: swap.cpp,v 1.2 2004/11/01 15:19:04 jpr Exp $
//=======================================================================

#include <iostream>
#include <vector>
#include <string>
using namespace std;

template <typename T>
void Swap(T& a, T& b)
{
    T temp = a;
    a = b;
    b = temp;
}

int main()
{
    int a = 1;
    int b = 2;
    Swap(a, b);
    cout << "Swapping integers: " << a << ' ' << b << endl;

    string s1 = "hello";
    string s2 = "world";
    Swap(s1, s2);
    cout << "Swapping strings: " << s1 << ' ' << s2 << endl;

    vector<int> v1(10, 1); // 10 elements, all initialized to 1
    vector<int> v2(5, 2);  // 5 elements, all initialized to 2
    
Swap(v1, v2);
    cout << "Swapping vectors: sizes: "
         << v1.size() << ' ' << v2.size() << endl;
    cout << "\tVector v1: ";
    for (unsigned i = 0; i < v1.size(); ++i) cout << v1[i] << ' ';
    cout << endl;
    cout << "\tVector v2: ";
    for (unsigned i = 0; i < v2.size(); ++i) cout << v2[i] << ' ';
    cout << endl;
}
    
