//=======================================================================
// Basic C++: classe Fifo
//      Utilization of class Fifo
//-----------------------------------------------------------------------
// Jean-Paul Rigault --- Copyright 2003
// $Id: main_Fifo2.cpp,v 1.2 2004/11/01 15:19:04 jpr Exp $
//=======================================================================

#include <cstdio>
#include <string>
#include <iostream>
using namespace std;

#include "Fifo.h"
#include "Stack.h"

int main()
{
    // Fifo of strings

    Fifo<string, 10> fs;

    string s1 = "hello";
    string s2 = "world";
    fs.put(s1);
    fs.put(s2);

    while (!fs.is_empty())
    {
        printf("%s ", fs.get().data());
    }
    putchar('\n');

    // Stack of Fifo's

    Fifo<string, 10> fs1;
    fs1.put("hello");
    fs1.put("world");

    Fifo<string, 10> fs2;
    fs2.put("bonjour");
    fs2.put("monde");

    Stack<Fifo<string, 10>, 5> stfs;
    stfs.push(fs2);
    stfs.push(fs1);

    try
    {
        while(true) fs = stfs.pop();
    }
    catch (Stack<Fifo<string, 10>, 5>::Empty&)
    {
        fprintf(stderr, "Stack<Fifo<string, 10>, 5> empty\n");
    }
    // Here fs has the last *valid* value returned by stfs.pop()
    try
    {
        fs.put("cruel");
        while (true) printf("%s ", fs.get().data());
    }
    catch (Fifo<string, 10>::Empty)
    {
        fprintf(stderr, "Fifo<string, 10> empty\n");
    }
    putchar('\n');
 
    return 0;
}
    
