//=======================================================================
// Basic C++: Index et rfrences croises : la classe Index
//-----------------------------------------------------------------------
// Jean-Paul Rigault --- Copyright 2003
// $Id: Index.cpp,v 1.1 2005/05/03 12:50:31 jpr Exp $
//=======================================================================

#include <algorithm>
using namespace std;

#include "stl_extensions.h"
using namespace JPR_STL_EXTENSIONS; 

#include "Index.h"


// Accesseur pour obtenir l'ensemble des numros de ligne d'un mot

const set<int>& Index::operator[](const string& w) const
{
    const_iterator it = _index.find(w);
    if (it == _index.end())
        throw Not_Found();
    else
        return it->second;
}

// Oprateur d'affichage : on ne peut pas utiliser la fonction display()
// des collections, car set<> n'a pas d'oprateur << (on pourrait lui en donner
// un...)

ostream& operator<<(ostream& os, const Index& index)
{
    for (Index::const_iterator it = index._index.begin();
         it != index._index.end(); ++it)
    {
        os << it->first << " : ";
        display(os, it->second);
        os << '\n';
    }
    return os;            
}
