//=======================================================================
// Basic C++: procedural programming
//      A Fifo class: implementation
//-----------------------------------------------------------------------
// Jean-Paul Rigault --- Copyright 2003
// $Id: Fifo.cpp,v 1.2 2004/11/01 15:19:04 jpr Exp $
//=======================================================================

#include "Fifo.h"

template <typename ELEM>
Fifo<ELEM>::Fifo(int n)
{
    _geti = 0;
    _nmax = n;
    _n = 0;
    _tab = new ELEM[n];
}

template <typename ELEM>
void Fifo<ELEM>::put(ELEM c)
{
    if (_n >= _nmax) throw Full();
    int puti = (_geti + _n) % _nmax;
    ++_n;
    _tab[puti] = c;
}

template <typename ELEM>
ELEM Fifo<ELEM>::get()
{
    if (_n <= 0) throw Empty();
    ELEM c = _tab[_geti];
    _geti = (_geti + 1) % _nmax;
    --_n;
    return c;
}

template <typename ELEM>
bool Fifo<ELEM>::is_full() const
{
    return _n >= _nmax;
}

template <typename ELEM>
bool Fifo<ELEM>::is_empty() const
{
    return _n <= 0;
}
