//=======================================================================
// Basic C++: procedural programming
//      Checking for palindromes
//-----------------------------------------------------------------------
// Jean-Paul Rigault --- Copyright 2003
// $Id: palindrome.cpp,v 1.2 2004/11/01 15:19:04 jpr Exp $
//=======================================================================

#include <string>
#include <iostream>
#include <stdexcept>
using namespace std;

bool is_palindrome(string s);

int main()
{
    string word;

    while (cin >> word)
    {
        cout << word << " is" << (is_palindrome(word) ? "" : " not")
             << " a palindrome" << endl;
    }

    // Just checking exceptions

    cout << "Checking exceptions" << endl;

    // The following does not throw
    cout << "using operator[]: " << word[word.size()] << endl;
   
    try
    {
        // This throws
        cout  << "using at(): " << word.at(word.size()) << endl;
    }
    catch (out_of_range)
    {
        cerr << "*** Out of Range exception" << endl;
    }
}

bool is_palindrome(string s)
{
    int i;
    int j;

    for (i = 0, j = s.size() - 1; i < j; ++i, --j)
    {
        if (s[i] != s[j]) return false;
    }
    return true;
}
