//=======================================================================
// Basic C++: class Expression
//      Utilization
//-----------------------------------------------------------------------
// Jean-Paul Rigault --- Copyright 2003
// $Id: main_Expr.cpp,v 1.3 2005/02/08 17:08:15 jpr Exp $
//=======================================================================

#include <iostream>
using namespace std;

#include "Expr.h"

// e0 = 3
Expr *pe0 = new Constant(3);

// e00 = -e0
Expr *pe00 = new Unary_Minus(pe0);

// e1 = e0*e00
Expr *pe1 = new Binary_Mult(pe0, pe00);

// e2 = -(2 + 3)*4 - 5/2 == -22
Expr *pe2 = new Binary_Minus(
               new Binary_Mult(
                   new Unary_Minus(
                       new Binary_Plus(
                           new Constant(2),
                           new Constant(3)
                        )
                    ),
                   new Constant(4)
                ),
               new Binary_Div(
                   new Constant(5),
                   new Constant(2)
                )
            );


int main()
{
    cout << "e0 = "  << pe0->eval()  << '\n';
    cout << "e00 = " << pe00->eval() << '\n';
    cout << "e1 = "  << pe1->eval()  << '\n';
    cout << "e2 = "  << pe2->eval()  << '\n';

    /*
    // Exemple of use of variables
    Variable_Ref *pv = new Variable_Ref("foo");
    cout << "pv = " << pv->eval() << endl;
    Expr *pev = new Binary_Plus(pv, new Constant(1));
    Expr *pv1 = new Assignment(pv, pev);
    cout << "pv1 = " << pv1->eval() << endl;
    */

}
