//--------------------------------------------------------------
//      A Stack class template Stack with exceptions
//              Specification
//--------------------------------------------------------------
// Jean-Paul Rigault: Basic C++
// $Id: Stack.h,v 1.2 2004/11/01 15:19:04 jpr Exp $
//--------------------------------------------------------------

#ifndef _STACK_H_
#define _STACK_H_

template <typename ELEM, int N>
class Stack
{
private:
    ELEM _tab[N];
    int _top;

public:
    // Exception classes
    class Full {};
    class Empty {};

    Stack();
    void push(ELEM);
    ELEM pop();
    bool is_full() const;
    bool is_empty() const;
};

// We suppose the "inclusion model" for templates
#include "Stack.cpp"

#endif
